/*
 * debug - debug_msr.c
 * 	version 0.0.2
 * 
 * Copyright (C) 2007  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <debug_msr.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <errno.h>

static int msr_fd = -1;

int d_rdmsr(unsigned long msr, uint64_t *val)
{
	int ret;

	if (msr_fd == -1)
		return -ENOSYS;

	if (lseek(msr_fd, msr, SEEK_SET) == -1)
		return -errno;

	ret = read(msr_fd, val, 8);
	if (ret < 8)
		return (ret < 0) ? -errno : -EINVAL;	/* FIXME: other error?*/
	return 0;
}

int d_wrmsr(unsigned long msr, uint64_t *val)
{
	int ret;

	if (msr_fd == -1)
		return -ENOSYS;

	if (lseek(msr_fd, msr, SEEK_SET) == -1)
		return -errno;

	ret = write(msr_fd, val, 8);
	if (ret < 8)
		return (ret < 0) ? -errno : -EINVAL;	/* FIXME: other error?*/
	return 0;
}

int d_msrinit(int cpu)
{
	msr_fd = open("/dev/cpu/0/msr", O_RDWR);
	if (msr_fd == -1) {
		perror("d_msrinit: open");
		return -1;
	}
	return 0;
}
